Index: trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/jthermcalc_e107.F	(revision 2464)
@@ -1084,19 +1081,19 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,klev,auxcoltab,nz2,limdown,limup)
-      do i=1,klev
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
          !O3 interpolated coefficient
-         jfotsout(indexint,7,klev-i+1) = 
-     $        jfotsout(indexint,7,klev) *
+         jfotsout(indexint,7,nlayer-i+1) = 
+     $        jfotsout(indexint,7,nlayer) *
      $        (wm(i)*auxjo3(ind+1) + wp(i)*auxjo3(ind))
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,klev
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,klev-i+1) = 
-     $           jfotsout(indexint,13,klev) *
+            jfotsout(indexint,13,nlayer-i+1) = 
+     $           jfotsout(indexint,13,nlayer) *
      $           (wm(i)*auxjno2(ind+1) + wp(i)*auxjno2(ind))
          enddo
@@ -1107,5 +1104,292 @@
 c     End of interpolation to obtain photoabsorption rates
 
-
+c     Coefficients are refered to Sun-Mars distance
+c     Correction to the Sun-Venus distance (fixed)
+
+      jfotsout(:,:,:)=jfotsout(:,:,:)*(1.52/dist_sol)**2
+
+      end
+
+c**********************************************************************
+c**********************************************************************
+
+      subroutine column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
+     $     co2colx,o3pcolx, n2colx, cocolx)
+
+c     mar 2014        gg            adapted to Venus GCM
+c     nov 2002        fgg           first version
+
+c**********************************************************************
+      use dimphy
+      use param_v4_h
+      implicit none
+
+c    common variables and constants
+#include "clesphys.h"
+#include "mmol.h"
+
+c    local parameters and variables
+
+c     input and output variables
+
+      integer    ig
+      integer    chemthermod
+      integer    nesptherm                   !# of species undergoing
+chemistry, input
+      real       rm(klev,nesptherm)         !densities (cm-3), input
+      real       tx(klev)                   !temperature profile, input
+      real       iz(klev+1)                 !height profile, input
+      real       zenit                      !SZA, input
+      real       co2colx(klev)              !column density of CO2 (cm^-2), output
+      real       o3pcolx(klev)              !column density of O(3P)(cm^-2), output
+      real       n2colx(klev)               !N2 column density (cm-2), output
+      real       cocolx(klev)               !CO column density (cm-2), output
+
+c     local variables
+
+      real       xx
+      real       grav(klev)
+      real       Hco2,Ho3p,Ho2,Hh2,Hh2o,Hh2o2
+      real       Ho3,Hn2,Hn,Hno,Hco,Hh,Hno2
+
+      real       co2x(klev)
+      real       o3px(klev)
+      real       cox(klev)
+      real       n2x(klev)
+      real       nx(klev)
+
+      integer    i,j,k,icol,indexint          !indexes
+
+      integer    nz3
+
+      integer    jj
+      real*8      esp(klev*2)
+      real*8      ilayesp(klev*2)
+      real*8      szalayesp(klev*2)
+      integer     nlayesp
+      real*8      zmini
+      real*8      depth
+      real*8      espco2, espo2, espo3p, esph2, esph2o, esph2o2,espo3
+      real*8      espn2,espn,espno,espco,esph,espno2
+      real*8      rcmnz, rcmmini
+      real*8      szadeg
+
+! Tracer indexes in the thermospheric chemistry:
+!!! ATTENTION. These values have to be identical to those in euvheat.F90
+!!! If the values are changed there, the same has to be done here  !!!
+
+      integer,parameter :: ix_co2=1
+      integer,parameter :: ix_n2=13
+      integer,parameter :: ix_o=3
+      integer,parameter :: ix_co=4
+
+c*************************PROGRAM STARTS*******************************
+
+      nz3 = klev*2
+      do i=1,klev
+        xx = ( radio + iz(i) ) * 1.e5    ! conversion [km] ---> [cm]
+         grav(i) = gg * masa /(xx**2)    ! [cm/s2]
+      end do
+
+      !Scale heights  H = kT /Mg  -->  [cm]
+      xx = kboltzman * tx(klev) * n_avog / grav(klev)   ! g cm mol-1
+
+      Ho3p  = xx / mmolo
+      Hco2  = xx / mmolco2
+      Hco   = xx / mmolco
+      Hn2   = xx / mmoln2
+      Hn    = xx / mmoln
+
+      !Only if O3 chem. required
+c      if(chemthermod.ge.1) 
+!     $     Ho3   = xx / mmol(igcm_o3)
+c     $     Ho3   = xx / mmolo3
+c      !Only if N or ion chem.
+c      if(chemthermod.ge.2) then
+c         Hn2   = xx / mmoln2
+c         Hn    = xx / mmoln
+c         Hno   = xx / mmolno
+c         Hno2  = xx / mmolno2
+c      endif
+      ! first loop in altitude : initialisation
+      do i=klev,1,-1
+         !Column initialisation
+         co2colx(i)  = 0.
+         o3pcolx(i)  = 0.
+         n2colx(i)   = 0.
+         cocolx(i)   = 0.
+
+         !--Densities [cm-3]
+         co2x(i)  = rm(i,ix_co2)
+         o3px(i)  = rm(i,ix_o)
+         cox(i)   = rm(i,ix_co)
+         n2x(i)   = rm(i,ix_n2)
+
+c         write(*,*), '--jthermcalc--', co2x(i)
+
+         !Only if O3 chem. required
+c         if(chemthermod.ge.1) 
+c     $        o3x(i)   = rm(i,i_o3)
+c         !Only if Nitrogen of ion chemistry requested
+c         if(chemthermod.ge.2) then
+c            n2x(i)   = rm(i,i_n2)
+c            nx(i)    = rm(i,i_n)
+c            nox(i)   = rm(i,i_no)
+c            no2x(i)  = rm(i,i_no2)
+c         endif
+      enddo     ! end first loop
+
+      ! second loop in altitude : column calculations
+      do i=klev,1,-1
+         !Routine to calculate the geometrical length of each layer
+         call espesor_optico_A(ig,i,zenit,iz(i),nz3,iz,esp,ilayesp,
+     $         szalayesp,nlayesp, zmini)
+         if(ilayesp(nlayesp).eq.-1) then
+            co2colx(i)=1.e25
+            o3pcolx(i)=1.e25
+            n2colx(i)=1.e25
+            cocolx(i)=1.e25
+
+c            o2colx(i)=1.e25
+c            o3pcolx(i)=1.e25
+c            h2colx(i)=1.e25
+c            h2ocolx(i)=1.e25
+c            h2o2colx(i)=1.e25
+c            o3colx(i)=1.e25
+c            ncolx(i)=1.e25
+c            nocolx(i)=1.e25
+
+c            cocolx(i)=1.e25
+c            hcolx(i)=1.e25
+c            no2colx(i)=1.e25
+         else
+            rcmnz = ( radio + iz(klev) ) * 1.e5    ! km --> cm
+            rcmmini = ( radio + zmini ) * 1.e5
+            !Column calculation taking into account the geometrical
+            !depth 
+            !calculated before
+            do j=1,nlayesp
+               jj=ilayesp(j)
+               !Top layer
+               if(jj.eq.klev) then
+                  if(zenit.le.60.) then
+                     o3pcolx(i)=o3pcolx(i)+o3px(klev)*Ho3p*esp(j)
+     $                    *1.e-5
+                     co2colx(i)=co2colx(i)+co2x(klev)*Hco2*esp(j)
+     $                    *1.e-5
+                     cocolx(i)=cocolx(i)+cox(klev)*Hco*esp(j)
+     $                    *1.e-5
+                     n2colx(i)=n2colx(i)+n2x(klev)*Hn2*esp(j)
+     $                    *1.e-5
+
+c                     h2o2colx(i)=h2o2colx(i)+
+c     $                    h2o2x(klev)*Hh2o2*esp(j)*1.e-5
+c                     o2colx(i)=o2colx(i)+o2x(klev)*Ho2*esp(j)
+c     $                    *1.e-5
+c                     h2colx(i)=h2colx(i)+h2x(klev)*Hh2*esp(j)
+c     $                    *1.e-5
+c                     h2ocolx(i)=h2ocolx(i)+h2ox(klev)*Hh2o*esp(j)
+c     $                    *1.e-5                     
+c                     cocolx(i)=cocolx(i)+cox(klev)*Hco*esp(j)
+c     $                    *1.e-5
+c                     hcolx(i)=hcolx(i)+hx(klev)*Hh*esp(j)
+c     $                    *1.e-5
+                     !Only if O3 chemistry required
+c                     if(chemthermod.ge.1) o3colx(i)=
+c     $                    o3colx(i)+o3x(klev)*Ho3*esp(j)
+c     $                    *1.e-5
+                     !Only if N or ion chemistry requested
+c                     if(chemthermod.ge.2) then
+c                        n2colx(i)=n2colx(i)+n2x(klev)*Hn2*esp(j)
+c     $                    *1.e-5
+
+c                     endif
+                  else if(zenit.gt.60.) then
+                     espco2 =sqrt((rcmnz+Hco2)**2 -rcmmini**2) - esp(j)
+                     espo3p = sqrt((rcmnz+Ho3p)**2 -rcmmini**2)- esp(j)
+                     espco  = sqrt((rcmnz+Hco)**2 -rcmmini**2) - esp(j)
+                     espn2 =sqrt((rcmnz+Hn2)**2-rcmmini**2)-esp(j)
+                     espn  =sqrt((rcmnz+Hn)**2-rcmmini**2)  - esp(j)
+
+c                     espo2  = sqrt((rcmnz+Ho2)**2 -rcmmini**2) - esp(j)
+c                     esph2  = sqrt((rcmnz+Hh2)**2 -rcmmini**2) - esp(j)
+c                     esph2o = sqrt((rcmnz+Hh2o)**2 -rcmmini**2)- esp(j)
+c                     esph2o2= sqrt((rcmnz+Hh2o2)**2-rcmmini**2)- esp(j)
+c                     esph   = sqrt((rcmnz+Hh)**2 -rcmmini**2)  - esp(j)
+                     !Only if O3 chemistry required
+c                     if(chemthermod.ge.1)                     
+c     $                   espo3=sqrt((rcmnz+Ho3)**2-rcmmini**2)-esp(j)
+c                     !Only if N or ion chemistry requested
+c                     if(chemthermod.ge.2) then
+c                        espn2 =sqrt((rcmnz+Hn2)**2-rcmmini**2)-esp(j)
+c                        espn  =sqrt((rcmnz+Hn)**2-rcmmini**2)  - esp(j)
+c                        espno =sqrt((rcmnz+Hno)**2-rcmmini**2) - esp(j)
+c                        espno2=sqrt((rcmnz+Hno2)**2-rcmmini**2)- esp(j)
+c                     endif
+
+                     co2colx(i) = co2colx(i) + espco2*co2x(klev)
+                     o3pcolx(i) = o3pcolx(i) + espo3p*o3px(klev)
+                     cocolx(i)  = cocolx(i)  + espco*cox(klev)
+                     n2colx(i)  = n2colx(i)  + espn2*n2x(klev)
+
+c                     o2colx(i)  = o2colx(i)  + espo2*o2x(klev)
+c                     h2colx(i)  = h2colx(i)  + esph2*h2x(klev)
+c                     h2ocolx(i) = h2ocolx(i) + esph2o*h2ox(klev)
+c                     h2o2colx(i)= h2o2colx(i)+ esph2o2*h2o2x(klev)
+c                     cocolx(i)  = cocolx(i)  + espco*cox(klev)
+c                     hcolx(i)   = hcolx(i)   + esph*hx(klev)
+                     !Only if O3 chemistry required
+c                     if(chemthermod.ge.1)                      
+c     $                  o3colx(i) = o3colx(i)  + espo3*o3x(klev)
+c                     !Only if N or ion chemistry requested
+c                     if(chemthermod.ge.2) then
+c                        n2colx(i)  = n2colx(i)  + espn2*n2x(klev)
+c                        ncolx(i)   = ncolx(i)   + espn*nx(klev)
+c                        nocolx(i)  = nocolx(i)  + espno*nox(klev)
+c                        no2colx(i) = no2colx(i) + espno2*no2x(klev)
+c                     endif
+                  endif !Of if zenit.lt.60
+               !Other layers
+               else
+                  co2colx(i)  = co2colx(i) +
+     $                 esp(j) * (co2x(jj)+co2x(jj+1)) / 2.
+                  o3pcolx(i)  = o3pcolx(i) +
+     $                 esp(j) * (o3px(jj)+o3px(jj+1)) / 2.
+                  cocolx(i)   = cocolx(i) +
+     $                 esp(j) * (cox(jj)+cox(jj+1)) / 2.
+                  n2colx(i)   = n2colx(i) +
+     $                 esp(j) * (n2x(jj)+n2x(jj+1)) / 2.
+
+c
+c                  o2colx(i)   = o2colx(i) + 
+c     $                 esp(j) * (o2x(jj)+o2x(jj+1)) / 2.
+c                  h2colx(i)   = h2colx(i) + 
+c     $                 esp(j) * (h2x(jj)+h2x(jj+1)) / 2.
+c                  h2ocolx(i)  = h2ocolx(i) + 
+c     $                 esp(j) * (h2ox(jj)+h2ox(jj+1)) / 2.
+c                  h2o2colx(i) = h2o2colx(i) + 
+c     $                 esp(j) * (h2o2x(jj)+h2o2x(jj+1)) / 2.
+c                  hcolx(i)    = hcolx(i) + 
+c     $                 esp(j) * (hx(jj)+hx(jj+1)) / 2.
+                  !Only if O3 chemistry required
+c                  if(chemthermod.ge.1) 
+c     $                 o3colx(i) = o3colx(i) + 
+c     $                 esp(j) * (o3x(jj)+o3x(jj+1)) / 2.
+c                  !Only if N or ion chemistry requested
+c                  if(chemthermod.ge.2) then
+c                     n2colx(i)   = n2colx(i) + 
+c     $                 esp(j) * (n2x(jj)+n2x(jj+1)) / 2.
+c                     ncolx(i)    = ncolx(i) + 
+c     $                    esp(j) * (nx(jj)+nx(jj+1)) / 2.
+c                     nocolx(i)   = nocolx(i) + 
+c     $                    esp(j) * (nox(jj)+nox(jj+1)) / 2.
+c                     no2colx(i)  = no2colx(i) + 
+c     $                    esp(j) * (no2x(jj)+no2x(jj+1)) / 2.
+c                  endif
+
+               endif  !Of if jj.eq.klev
+            end do    !Of do j=1,nlayesp
+         endif        !Of ilayesp(nlayesp).eq.-1
+      enddo           !Of do i=klev,1,-1
       return
 
@@ -1113,6 +1397,340 @@
 
 
-
-
-
-
+c**********************************************************************
+c**********************************************************************
+
+      subroutine interfast(wm,wp,nm,p,nlayer,pin,nl,limdown,limup)
+C
+C subroutine to perform linear interpolation in pressure from 1D profile 
+C escin(nl) sampled on pressure grid pin(nl) to profile
+C escout(nlayer) on pressure grid p(nlayer).
+C
+      real*8 wm(nlayer),wp(nlayer),p(nlayer)
+      integer nm(nlayer)
+      real*8 pin(nl)
+      real*8 limup,limdown
+      integer nl,nlayer,n1,n,np,nini
+      nini=1
+      do n1=1,nlayer
+         if(p(n1) .gt. limup .or. p(n1) .lt. limdown) then
+            wm(n1) = 0.d0
+            wp(n1) = 0.d0
+         else
+            do n = nini,nl-1
+               if (p(n1).ge.pin(n).and.p(n1).le.pin(n+1)) then
+                  nm(n1)=n
+                  np=n+1
+                  wm(n1)=abs(pin(n)-p(n1))/(pin(np)-pin(n))
+                  wp(n1)=1.d0 - wm(n1)
+                  nini = n
+                  exit
+               endif
+            enddo
+         endif
+      enddo
+      return
+      end
+
+c**********************************************************************
+c**********************************************************************
+
+      subroutine espesor_optico_A (ig,capa, szadeg,z,
+     @                   nz3,iz,esp,ilayesp,szalayesp,nlayesp, zmini)
+
+c     fgg              nov 03      Adaptation to Martian model
+c     malv             jul 03      Corrected z grid. Split in alt & frec
+codes
+c     fgg              feb 03      first version
+*************************************************************************
+      use dimphy
+      use param_v4_h
+      implicit none
+
+c     arguments
+
+      real        szadeg                ! I. SZA [rad]
+      real        z                     ! I. altitude of interest [km]
+      integer     nz3,ig                   ! I. dimension of esp, ylayesp, etc...
+                                        !  (=2*klev= max# of layers in
+                                        !  ray path)
+      real     iz(klev+1)              ! I. Altitude of each layer
+      real*8        esp(nz3)            ! O. layer widths after geometrically 
+                                        !    amplified; in [cm] except
+                                        !    at TOA
+                                        !    where an auxiliary value is
+                                        !    used
+      real*8        ilayesp(nz3)        ! O. Indexes of layers along ray path
+      real*8        szalayesp(nz3)      ! O. SZA [deg]    "     "     "
+      integer       nlayesp
+!      real*8        nlayesp             ! O. # layers along ray path at
+!      this z
+      real*8        zmini               ! O. Minimum altitud of ray path [km]
+
+c     local variables and constants
+
+        integer     j,i,capa
+        integer     jmin                  ! index of min.altitude along ray path
+        real*8      szarad                ! SZA [deg]
+        real*8      zz
+        real*8      diz(klev+1)
+        real*8      rkmnz                 ! distance TOA to center of Planet [km]
+        real*8      rkmmini               ! distance zmini to center of P [km] 
+        real*8      rkmj                  ! intermediate distance to C of P [km]
+
+c external function
+        external  grid_R8          ! Returns index of layer containing the altitude
+                                ! of interest, z; for example, if 
+                                ! zkm(i)=z or zkm(i)<z<zkm(i+1) =>
+                                ! grid(z)=i 
+        integer   grid_R8
+
+*************************************************************************     
+        szarad = dble(szadeg)*3.141592d0/180.d0
+        zz=dble(z)
+        do i=1,klev
+           diz(i)=dble(iz(i))
+        enddo
+        do j=1,nz3
+          esp(j) = 0.d0
+          szalayesp(j) = 777.d0
+          ilayesp(j) = 0
+        enddo
+        nlayesp = 0
+
+        ! First case: szadeg<60
+        ! The optical thickness will be given by  1/cos(sza)
+        ! We deal with 2 different regions:
+        !   1: First, all layers between z and ztop ("upper part of
+        !   ray")
+        !   2: Second, the layer at ztop
+        if(szadeg.lt.60.d0) then
+
+           zmini = zz
+           if(abs(zz-diz(klev)).lt.1.d-3) goto 1357
+           ! 1st Zone: Upper part of ray
+           !
+           do j=grid_R8(zz,diz,klev),klev-1
+             nlayesp = nlayesp + 1
+             ilayesp(nlayesp) = j
+             esp(nlayesp) = (diz(j+1)-diz(j)) / cos(szarad)        ! [km]
+             esp(nlayesp) = esp(nlayesp) * 1.d5                    ! [cm]
+             szalayesp(nlayesp) = szadeg
+           end do
+
+           ! 
+           ! 2nd Zone: Top layer
+ 1357      continue
+           nlayesp = nlayesp + 1
+           ilayesp(nlayesp) = klev 
+           esp(nlayesp) = 1.d0 / cos(szarad)         ! aux. non-dimens. factor
+           szalayesp(nlayesp) = szadeg
+
+        ! Second case:  60 < szadeg < 90
+        ! The optical thickness is evaluated.
+        !    (the magnitude of the effect of not using cos(sza) is 3.e-5 
+        !     for z=60km & sza=30, and 5e-4 for z=60km & sza=60,
+        !     approximately)
+        ! We deal with 2 different regions:
+        !   1: First, all layers between z and ztop ("upper part of
+        !   ray")
+        !   2: Second, the layer at ztop ("uppermost layer")
+        else if(szadeg.le.90.d0.and.szadeg.ge.60.d0) then
+
+           zmini=(radio+zz)*sin(szarad)-radio
+           rkmmini = radio + zmini
+
+           if(abs(zz-diz(klev)).lt.1.d-4) goto 1470
+
+           ! 1st Zone: Upper part of ray
+           !
+           do j=grid_R8(zz,diz,klev),klev-1
+              nlayesp = nlayesp + 1 
+              ilayesp(nlayesp) = j
+              esp(nlayesp) = 
+     #             sqrt( (radio+diz(j+1))**2 - rkmmini**2 ) -
+     #             sqrt( (radio+diz(j))**2 - rkmmini**2 )           ! [km]
+              esp(nlayesp) = esp(nlayesp) * 1.d5                    ! [cm]
+              rkmj = radio+diz(j)
+              szalayesp(nlayesp) = asin( rkmmini/rkmj )             ! [rad]
+              szalayesp(nlayesp) = szalayesp(nlayesp) * 180.d0/3.141592
+! [deg]
+           end do
+ 1470      continue
+           ! 2nd Zone:  Uppermost layer of ray.
+           !
+           nlayesp = nlayesp + 1 
+           ilayesp(nlayesp) = klev
+           rkmnz = radio+diz(klev)
+           esp(nlayesp)  =  sqrt( rkmnz**2 - rkmmini**2 )       ! aux.factor[km]
+           esp(nlayesp)  =  esp(nlayesp) * 1.d5                 ! aux.f. [cm]
+           szalayesp(nlayesp) = asin( rkmmini/rkmnz )           ! [rad]
+           szalayesp(nlayesp) = szalayesp(nlayesp) * 180.d0/3.141592! [deg]
+
+
+        ! Third case:  szadeg > 90
+        ! The optical thickness is evaluated.
+        ! We deal with 5 different regions:
+        !   1: all layers between z and ztop ("upper part of ray")
+        !   2: the layer at ztop ("uppermost layer")
+        !   3: the lowest layer, at zmini
+        !   4: the layers increasing from zmini to z (here SZA<90)
+        !   5: the layers decreasing from z to zmini (here SZA>90)
+        else if(szadeg.gt.90.d0) then
+
+           zmini=(radio+zz)*sin(szarad)-radio
+           rkmmini = radio + zmini
+
+           if(zmini.lt.diz(1)) then         ! Can see the sun?  No => esp(j)=inft
+             nlayesp = nlayesp + 1 
+             ilayesp(nlayesp) = - 1     ! Value to mark "no sun on view"
+!             esp(nlayesp) = 1.e30
+
+           else
+              jmin=grid_R8(zmini,diz,klev)+1
+              
+
+              if(abs(zz-diz(klev)).lt.1.d-4) goto 9876
+
+              ! 1st Zone: Upper part of ray
+              !
+              do j=grid_R8(zz,diz,klev),klev-1
+                nlayesp = nlayesp + 1 
+                ilayesp(nlayesp) = j
+                esp(nlayesp) = 
+     $                sqrt( (radio+diz(j+1))**2 - rkmmini**2 ) -
+     $                sqrt( (radio+diz(j))**2 - rkmmini**2 )          ! [km]
+                esp(nlayesp) = esp(nlayesp) * 1.d5                    ! [cm]
+                rkmj = radio+diz(j)
+                szalayesp(nlayesp) = asin( rkmmini/rkmj )              ! [rad]
+                szalayesp(nlayesp) = szalayesp(nlayesp) *180.d0/3.141592
+! [deg]
+              end do
+
+ 9876         continue
+              ! 2nd Zone:  Uppermost layer of ray.
+              !
+              nlayesp = nlayesp + 1 
+              ilayesp(nlayesp) = klev
+              rkmnz = radio+diz(klev)
+              esp(nlayesp) =  sqrt( rkmnz**2 - rkmmini**2 ) !aux.factor[km]
+              esp(nlayesp) = esp(nlayesp) * 1.d5 !aux.f.[cm]
+              szalayesp(nlayesp) = asin( rkmmini/rkmnz )           ! [rad]
+              szalayesp(nlayesp) = szalayesp(nlayesp) *180.d0/3.141592 ! [deg]
+
+              ! 3er Zone: Lowestmost layer of ray
+              !
+              if ( jmin .ge. 2 ) then      ! If above the planet's surface
+                j=jmin-1
+                nlayesp = nlayesp + 1 
+                ilayesp(nlayesp) = j
+                esp(nlayesp) = 2. * 
+     $                 sqrt( (radio+diz(j+1))**2 -rkmmini**2 )       ! [km]
+                esp(nlayesp) = esp(nlayesp) * 1.d5                   ! [cm]
+                rkmj = radio+diz(j+1)
+                szalayesp(nlayesp) = asin( rkmmini/rkmj ) ! [rad]
+                szalayesp(nlayesp) = szalayesp(nlayesp) *180.d0/3.141592
+! [deg]
+              endif
+
+              ! 4th zone: Lower part of ray, increasing from zmin to z
+              !    ( layers with SZA < 90 deg )
+              do j=jmin,grid_R8(zz,diz,klev)-1
+                nlayesp = nlayesp + 1 
+                ilayesp(nlayesp) = j
+                esp(nlayesp) = 
+     $                    sqrt( (radio+diz(j+1))**2 - rkmmini**2 )
+     $                  - sqrt( (radio+diz(j))**2 - rkmmini**2 )       ! [km]
+                esp(nlayesp) = esp(nlayesp) * 1.d5                     ! [cm]
+                rkmj = radio+diz(j)
+                szalayesp(nlayesp) = asin( rkmmini/rkmj )              ! [rad]
+                szalayesp(nlayesp) = szalayesp(nlayesp) *180.d0/3.141592
+! [deg]
+              end do
+
+              ! 5th zone: Lower part of ray, decreasing from z to zmin
+              !    ( layers with SZA > 90 deg )
+              do j=grid_R8(zz,diz,klev)-1, jmin, -1
+                nlayesp = nlayesp + 1 
+                ilayesp(nlayesp) = j
+                esp(nlayesp) = 
+     $                    sqrt( (radio+diz(j+1))**2 - rkmmini**2 )
+     $                  - sqrt( (radio+diz(j))**2 - rkmmini**2 )
+! [km]
+                esp(nlayesp) = esp(nlayesp) * 1.d5
+! [cm]
+                rkmj = radio+diz(j)
+                szalayesp(nlayesp) = 3.141592 - asin( rkmmini/rkmj )
+! [rad]
+                szalayesp(nlayesp) = szalayesp(nlayesp)*180.d0/3.141592
+! [deg]
+              end do
+
+           end if
+
+        end if
+
+        return
+
+        end
+
+
+c**********************************************************************
+c***********************************************************************
+
+        function grid_R8 (z, zgrid, nz)
+
+c Returns the index where z is located within vector zgrid
+c The vector zgrid must be monotonously increasing, otherwise program stops.
+c If z is outside zgrid limits, or zgrid dimension is nz<2, the program stops. 
+c
+c FGG     Aug-2004     Correct z.lt.zgrid(i) to .le. 
+c MALV    Jul-2003
+c***********************************************************************
+
+        implicit none
+
+c Arguments 
+        integer   nz
+        real*8      z
+        real*8      zgrid(nz)
+        integer   grid_R8
+
+c Local  
+        integer   i, nz1, nznew
+
+c*** CODE START 
+
+        if ( z .lt. zgrid(1) .or. z.gt.zgrid(nz) ) then 
+           write (*,*) ' GRID/ z outside bounds of zgrid '
+           write (*,*) ' z,zgrid(1),zgrid(nz) =', z,zgrid(1),zgrid(nz)
+           stop ' Serious error in GRID.F '
+        endif
+        if ( nz .lt. 2 ) then 
+           write (*,*) ' GRID/ zgrid needs 2 points at least ! '
+           stop ' Serious error in GRID.F '
+        endif
+        if ( zgrid(1) .ge. zgrid(nz) ) then 
+           write (*,*) ' GRID/ zgrid must increase with index'
+           stop ' Serious error in GRID.F '
+        endif
+
+        nz1 = 1
+        nznew = nz/2
+        if ( z .gt. zgrid(nznew) ) then
+           nz1 = nznew
+           nznew = nz
+        endif
+        do i=nz1+1,nznew
+           if ( z. eq. zgrid(i) ) then
+              grid_R8=i
+              return
+              elseif ( z .le. zgrid(i) ) then
+              grid_R8 = i-1
+              return
+           endif
+        enddo
+        grid_R8 = nz
+        return
+
+        end
+
Index: trunk/LMDZ.VENUS/libf/phyvenus/load_ksi.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/load_ksi.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/load_ksi.F	(revision 2464)
@@ -44,4 +44,5 @@
       real   lambdamin(nnuve),lambdamax(nnuve) ! in microns
       real   dlambda                  ! in microns 
+      logical upper
 
       nlve = klev
@@ -87,11 +88,21 @@
         read(10,*)
         read(10,*) m,Nb
-cc      GG modif below  
-        if (nlve.le.78.and.m.ne.nlve) then
-         write(*,*) 'This is subroutine load_ksi'
-         print*,'Dimension problem between ksi.txt and nlve'
-         print*,'N levels = ',m,nlve
-         stop
+CC vertical axis check
+        upper=.false.
+cc the number of levels read for the matrix (m) should be the number of levels of the GCM (nlve=klev)
+        if (m.ne.nlve) then
+CC When GCM axis has more levels than the matrix, we must be in the case
+cc with upper atmosphere, ie matrix limited to 78 levels and upper levels set to zero
+cc otherwise there is a problem
+         if ((m.eq.78).and.(nlve.gt.78)) then
+          upper=.true.
+         else
+          write(*,*) 'This is subroutine load_ksi'
+          print*,'Dimension problem between ksi.txt and nlve'
+          print*,'N levels = ',m,nlve
+          stop
+         endif
         endif
+cc wavelength check
         if (Nb.ne.nnuve) then
          write(*,*) 'This is subroutine load_ksi'
@@ -113,4 +124,13 @@
             read(10,format_lect) (ksive(i,j,band,mat),j=0,m+1) ! no unit
          enddo                  ! i
+cc case upper atmosphere: the level for space (m+1) should be raised to nlve+1
+         if (upper) then
+           do i=0,m
+             ksive(i,klev+1,band,mat)=ksive(i,m+1,band,mat)
+             ksive(i,m+1,band,mat)=0.
+           enddo
+             ksive(klev+1,:,band,mat)=ksive(m+1,:,band,mat)
+             ksive(m+1,:,band,mat)=0.
+         endif
         enddo                     ! band
 c       print*,"Matrice ",mat," lue"
Index: trunk/LMDZ.VENUS/libf/phyvenus/moldiff_red.F90
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/moldiff_red.F90	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/moldiff_red.F90	(revision 2464)
@@ -1,4 +1,4 @@
 subroutine moldiff_red(ngrid,nlayer,nq,pplay,pplev,pt,pq,&
-                       ptimestep,zzlay,pdteuv,pdtconduc,pdqdiff)
+                       ptimestep,pdteuv,pdtconduc,pdqdiff)
 
 USE chemparam_mod
@@ -8,11 +8,5 @@
 implicit none
 
-!#include "dimphys.h"
 #include "comcstfi.h"
-!#include "callkeys.h"
-!#include "comdiurn.h"
-!#include "chimiedata.h"
-!#include "tracer.h"
-!#include "conc.h"
 #include "diffusion.h"
 
@@ -26,5 +20,4 @@
       real ptimestep
       real pplay(ngrid,nlayer)
-      real zzlay(ngrid,nlayer)
       real pplev(ngrid,nlayer+1)
       real pq(ngrid,nlayer,nq)
@@ -67,5 +60,6 @@
       real*8,dimension(:),allocatable,save ::  wi,Wad,Uthermal,Lambdaexo,Hspecie
       real*8,dimension(:),allocatable,save :: Mtot1,Mtot2,Mraf1,Mraf2
-      character(len=20),dimension(14) :: ListeDiff
+      integer,parameter :: nb_esp_diff=15
+      character(len=20),dimension(nb_esp_diff) :: ListeDiff
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 !     tracer numbering in the molecular diffusion
@@ -130,4 +124,5 @@
 	ListeDiff(13)='o3'
 	ListeDiff(14)='n'
+	ListeDiff(15)='he'
 	i_esc_h=1000
 	i_esc_h2=1000
@@ -140,5 +135,5 @@
 	do nn=1,nq
 
-	do n=1,14
+	do n=1,nb_esp_diff
 	if (ListeDiff(n) .eq. tname(nn)) then
 	indic_diff(nn)=1
@@ -624,4 +619,7 @@
         enddo
         enddo
+
+! DEBUG
+!       print*,"rapport MASSE: ",Mtot2(:)/Mtot1(:)
 
 ! Check mass  conservation of each specie on column
Index: trunk/LMDZ.VENUS/libf/phyvenus/nirco2abs.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/nirco2abs.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/nirco2abs.F	(revision 2464)
@@ -189,5 +189,10 @@
                   if(pq(ig,l,ico2) .gt. 1.e-6) then
                      oco2gcm=pq(ig,l,io)/pq(ig,l,ico2)
-
+                     ! handle the rare cases when pq(ig,l,io)<0
+                     if (pq(ig,l,io).lt.0) then
+                       write(*,*) "nirco2abs: warning ig=",ig," l=",l,
+     &                            " pq(ig,l,io)=",pq(ig,l,io)
+                       oco2gcm=1.e6
+                     endif
                   else
                      oco2gcm=1.e6
Index: trunk/LMDZ.VENUS/libf/phyvenus/nlte_setup.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/nlte_setup.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/nlte_setup.F	(revision 2464)
@@ -177,7 +177,7 @@
                                 !! k19 & k20
 
-      k20x = 3.d-12
+c      k20x = 3.d-12
 c  TEST GG: double the values of Kvv as recently found by Sharma et al.2014
-c      k20x = 6.d-12   
+      k20x = 6.d-12   
 c  TEST GG: use the minimum value of the experimental bracket's values [1-6]
 c      k20x = 1.d-12 
